/****************************************************/
/* xZTNX                               */
/*                         written by shusakus sone */
/****************************************************/

import com.nttdocomo.device.location.AccelerationData;
import com.nttdocomo.device.location.AccelerationEventListener;
import com.nttdocomo.device.location.AccelerationSensor;
import com.nttdocomo.ui.Display;


	/////////////////////////////////////
	//	xZT[VXe
	//
	//	[g]
	//	@NX쐬
	//
	//	AstartŎϑX^[g
	//
	//	Bgetŉxf[^擾Bf[^́AasValueɊi[
	//
	//	CstopŎϑXgbv
	//
	//  DresumeŃW[ł
	/////////////////////////////////////


public class AS{

	//fobOtO
	private static final boolean DEBUG_FLAG=true;
	
	//xZT[CX^X
	private static AccelerationSensor as;
	
	//xZT[̎gp\ȃZT[ɓ
	private static int[] asAvail;

	//[p
	private static final int ROLL = 0;
	
	//sb`p
	private static final int PITCH = 1;
	
	//Xx
	private static final int ACCELERATION_X = 2;
	
	//Yx
	private static final int ACCELERATION_Y = 3;
	
	//Zx
	private static final int ACCELERATION_Z = 4;
	
	//XN[X
	private static final int SCREEN_ORIENTATION = 5;
	
	//ZT-̐
	private static final int AS_NUM = 6;
	
	//asAvail=as.getAvailableData()œeZTƂ̔rp
	private static final int AS_USING_COMPARE[] = {
		AccelerationSensor.ROLL,
		AccelerationSensor.PITCH,
		AccelerationSensor.ACCELERATION_X,
		AccelerationSensor.ACCELERATION_Y,
		AccelerationSensor.ACCELERATION_Z,
		AccelerationSensor.SCREEN_ORIENTATION,
	};
	
	//݂̉xZT[鐫\
	private static boolean[] asAvailFlag = new boolean[AS_NUM];
	
	//xZT[getDataƂ̃f[^͂ɓ
	private static AccelerationData ad;
	
	//xZT[ōŌɎ擾f[^ɓ
	private static int asValue[] = new int[AS_NUM];
	
	//ݎϑ
	private static boolean asRunning = false;
	
	public AS(){
		init();
	}
	
	/**
	  * xZT[CX^X擾
	  * xZT[̐\擾
	  */
	 private void init(){
		try{
			
			as = AccelerationSensor.getAccelerationSensor();
			asAvail = as.getAvailableData();
			
			for(int i = 0;i < asAvailFlag.length;i++)
				asAvailFlag[i] = false;
      
            //gѓdbT|[gxZT̎
			//(X,Y,Z,Roll,Picth,Screen)o^
			if(asAvail != null && asAvail.length > 0){
				for(int i = 0;i < asAvailFlag.length;i++){
					for(int j = 0;j < asAvail.length;j++){
						if(asAvail[j] == AS_USING_COMPARE[i]){
							asAvailFlag[i] = true;
							break;	
						}
					}
				}
			 }//end of if
			
		}catch(Throwable e){
			System.out.println("exception at init:"+e.toString());
		}
	}
	
	/**
	  * ϑ̊Jn
	  */
	public void start(){
		try{
			as.start(as.getIntervalResolution());
			asRunning = true;
		}catch(Exception e){
			System.out.println("exception at start:as.start already running:"+e.toString());
		}
		
	}

	/**
	  * ϑ̒~
	  */
	public void stop(){
		as.stop();
		asRunning = false;
	}
	
	/**
	  * W[ ܂ł̃f[^̂Ă
	  */
	public void resume(){
		if(asRunning){
			as.disposeData();
			start();
		}
	}
	
    /**
	  * ŐṼZT[f[^擾B
	  * @return XVĂtrue
	  */
	public boolean get(){
		boolean ret = false;
		if(asRunning){
			ad = as.getData();
			if(ad.size() != 0){
				useSensorData();
				ret = true;
			}
		}else{
			System.out.println("get: don't interval measurement");
		}
		return ret;
	}
	
	
	/**
	  * xf[^asValueɊi[
	  */
	 private void useSensorData() {
    
      try{
       //Ō̃[pƃsb`pasValueɊi[
       if(asAvailFlag[ROLL]){
        asValue[ROLL] = ad.getRoll()[ad.size()-1];
       }else{
        asValue[ROLL] = 0;
       }
      
       if(asAvailFlag[PITCH]){
        asValue[PITCH] = ad.getPitch()[ad.size()-1];
       }else{
        asValue[PITCH] = 0;
       }
      
     }catch(Exception e){
       //f[^𖳌
       for(int i = 0;i < asValue.length;i++){
        asValue[i] = 0;
       }
     }
    
     if(DEBUG_FLAG){
       System.out.println("ŏILlF[p:"+asValue[ROLL]
       +"sb`p:"+asValue[PITCH]);
     }
    
   }
	
    /**
	  * xZT̏ԂԂ̏Ԃ߂
	  */
	public static int AsState(){
		int state=0;
		int accele=0;
		int steer=0;
		
		if(asValue[PITCH] > -40 
			&& asValue[PITCH] <-20){
			accele=1; //forward
		}else{
			accele=0; //stop
		}
		
		if(asValue[ROLL] > -55 
			&&  asValue[ROLL] < -15){
			steer=-1; //left
		}else if(asValue[ROLL] > 15 
			&&  asValue[ROLL] < 55){
			steer=1; //right
		}else{
			steer=0;
		}
		
		if(accele>0){
		  if(steer==0){
		   state=Display.KEY_UP;
		  }else if(steer==-1){
		   state=Display.KEY_UPPER_LEFT;
		  }else if(steer==1){
		   state=Display.KEY_UPPER_RIGHT;
		  }
		}
		
		return state;
	}
}
