/**********************************************************/
/* `Q𓮂TvvO                      */
/*                          written by shusaku sone       */
/**********************************************************/

import com.nttdocomo.ui.Canvas;
import com.nttdocomo.ui.Display;
import com.nttdocomo.ui.Font;
import com.nttdocomo.ui.Graphics;
import com.nttdocomo.ui.IApplication;
import com.nttdocomo.ui.*;
import java.util.*;
import com.nttdocomo.device.*;

//w`QxNNX
public class IrCar extends IApplication{
	
	//Q[̃C
	IrCanvas canvas;
	
	// N\bh
	public void start(){
		PhoneSystem.setAttribute(PhoneSystem.DEV_BACKLIGHT, PhoneSystem.ATTR_BACKLIGHT_ON);
		PhoneSystem.setAttribute(PhoneSystem.DEV_KEYPAD, 1);
		canvas = new IrCanvas();
		Display.setCurrent(canvas);
	}
	// AvW[Ƃ̏
	public void resume(){
		canvas.resume();
	}
	
}

//Q[̃CsNXB
class IrCanvas extends Canvas implements Runnable{
	//fobNptOB
	private static final boolean DEBUG = true;
	
	//xZT[pfobNtO
	private static final boolean AS_DEBUG = true;
	//xZT[gptO
	private static boolean asFlag=false;
	
	
	//ʂ̉,c\萔
	private static final int DISPLAY_W = Display.getWidth();
	private static final int DISPLAY_H = Display.getHeight();
	
	//OtBbNXNX	
	private static Graphics g;
	//`QNX
	private static ChoroQ car;
	//L[NX
	private static Key key;
	//xZT
	private static AS as;

	
	/**
	  * RXgN^
	  */
	public IrCanvas(){
		//
		init();
		// XbhN
		Thread thread = new Thread(this);
		thread.start();
	}
	
	/**
	  * 
	  */
	private void init(){
		//`QNX̍쐬
		car=new ChoroQ(this);
		
		//L[NX̍쐬
		key=new Key();
		
		//xZT[NX̍쐬
		as=new AS();
		
		//OtBbNXNX̃CX^X̎擾
	    g=getGraphics();
	}//end of init()
	
	/**
	  * Xbh{
	  */
	public void run() {
		//C[v
		while(true){
			//L[̓o^
			key.registKeyEvent();
			
			//ϑĂ΍ŐV擾
			if(asFlag){
			  as.get();
			}
			
			//݂̃`Q̏
			try {
				calc();
			} catch (Exception e) {
				if (DEBUG) System.out.println("calc: " + e.toString());
			
			}
			//ʍXV
			try {
				paint(g);
			} catch (Exception e) {
				if (DEBUG) System.out.println("paint: " + e.toString());
			}
		}
	}//end of run
	



	//Q[sC\bhB
	public void calc() {
		calcPlay();	
	}//end of calc
	
	/**
	  * W[
	  */
	public void resume(){}//end of resume
	

	/**
	  * Cxg̏s.
	  * @param type - Cxg̃^Cv
	  * @param param - Cxg̃p[^
	  */
	public void processEvent(int type, int param) {
		if(type == Display.KEY_PRESSED_EVENT) {
			key.keyFlag |= (1L << param);
		} else if(type == Display.KEY_RELEASED_EVENT) {
			key.keyFlag &= ~(1L << param);
		}
	}//end of processEvent
	

	/**
	 C
	 */
	private void calcPlay(){
		
		//Ԃ̏
		int carState=0;
		carState=key.keyState();
		if(asFlag && carState != Display.KEY_SELECT){
			carState=as.AsState();
		}
		
		if(carState!=0) car.send(carState);
		
		//L[𗣂Ԃ̓Xgbv
		if(key.isKeyReleasedCheck()) car.stop();
		
		//xZT[ƃL[̐؂ւ
		if(key.isKeyPressed(Display.KEY_SOFT1)){
			asFlag = car.handlingChange();
			//xZT̃X^[gƃXgbv
			if(asFlag) as.start();
			else as.stop();
		
		}
		//KEY_SOFT2Ńoh؂ւ
		if(key.isKeyPressed(Display.KEY_SOFT2)){
			car.bandChange();
		}
	}//end of calc_play
	
	/**
	  * `揈
	  */	
	public void paint(Graphics g){
		g.lock();
		try{	
		}catch(Exception e){
			System.out.println("Excep at paint:"+e.toString());
		}
		g.unlock(true);
	}//end of paint

}
